## stalin 0.11

=== Makefile ===
# This is the original manually generated Makefile.  It may still be used
# to build the collector.
#
# Primary targets:
# gc.a - builds basic library
# c++ - adds C++ interface to library
# cords - adds cords (heavyweight strings) to library
# test - prints porting information, then builds basic version of gc.a,
#      	 and runs some tests of collector and cords.  Does not add cords or
#	 c++ interface to gc.a
# cord/de - builds dumb editor based on cords.
ABI_FLAG= 
# ABI_FLAG should be the cc flag that specifies the ABI.  On most
# platforms this will be the empty string.  Possible values:
# +DD64 for 64-bit executable on HP/UX.
# -n32, -n64, -o32 for SGI/MIPS ABIs.

AS_ABI_FLAG=$(ABI_FLAG)
# ABI flag for assembler.  On HP/UX this is +A64 for 64 bit
# executables.

CC=cc $(ABI_FLAG)
CXX=g++ $(ABI_FLAG)
AS=as $(AS_ABI_FLAG)
#  The above doesn't work with gas, which doesn't run cpp.
#  Define AS as `gcc -c -x assembler-with-cpp' instead.

# Redefining srcdir allows object code for the nonPCR version of the collector
# to be generated in different directories.
srcdir= .
VPATH= $(srcdir)

CFLAGS= -O -I$(srcdir)/include -DATOMIC_UNCOLLECTABLE -DNO_SIGNALS -DNO_EXECUTE_PERMISSION -DSILENT -DALL_INTERIOR_POINTERS

# To build the parallel collector on Linux, add to the above:
# -DGC_LINUX_THREADS -DPARALLEL_MARK -DTHREAD_LOCAL_ALLOC
# To build the parallel collector in a static library on HP/UX,
# add to the above:
# -DGC_HPUX_THREADS -DPARALLEL_MARK -DTHREAD_LOCAL_ALLOC -D_POSIX_C_SOURCE=199506L -mt
# To build the thread-safe collector on Tru64, add to the above:
# -pthread -DGC_OSF1_THREADS

# HOSTCC and HOSTCFLAGS are used to build executables that will be run as
# part of the build process, i.e. on the build machine.  These will usually
# be the same as CC and CFLAGS, except in a cross-compilation environment.
# Note that HOSTCFLAGS should include any -D flags that affect thread support.
HOSTCC=$(CC)
HOSTCFLAGS=$(CFLAGS)

# For dynamic library builds, it may be necessary to add flags to generate
# PIC code, e.g. -fPIC on Linux.

# Setjmp_test may yield overly optimistic results when compiled
# without optimization.

# These define arguments influence the collector configuration:
# -DSILENT disables statistics printing, and improves performance.
# -DFIND_LEAK causes GC_find_leak to be initially set.
#   This causes the collector to assume that all inaccessible
#   objects should have been explicitly deallocated, and reports exceptions.
#   Finalization and the test program are not usable in this mode.
# -DGC_SOLARIS_THREADS enables support for Solaris (thr_) threads.
#   (Clients should also define GC_SOLARIS_THREADS and then include
#   gc.h before performing thr_ or dl* or GC_ operations.)
#   Must also define -D_REENTRANT.
# -DGC_SOLARIS_PTHREADS enables support for Solaris pthreads.
#   (Internally this define GC_SOLARIS_THREADS as well.)
# -DGC_IRIX_THREADS enables support for Irix pthreads.  See README.irix.
# -DGC_HPUX_THREADS enables support for HP/UX 11 pthreads.
#   Also requires -D_REENTRANT or -D_POSIX_C_SOURCE=199506L. See README.hp.
# -DGC_LINUX_THREADS enables support for Xavier Leroy's Linux threads.
#   see README.linux.  -D_REENTRANT may also be required.
# -DGC_OSF1_THREADS enables support for Tru64 pthreads.
# -DGC_FREEBSD_THREADS enables support for FreeBSD pthreads.
#   Appeared to run into some underlying thread problems.
# -DGC_DARWIN_THREADS enables support for Mac OS X pthreads.
# -DGC_AIX_THREADS enables support for IBM AIX threads.
# -DGC_DGUX386_THREADS enables support for DB/UX on I386 threads.
#   See README.DGUX386.
# -DGC_WIN32_THREADS enables support for win32 threads.  That makes sense
#   for this Makefile only under Cygwin.
# -DGC_THREADS should set the appropriate one of the above macros.
#   It assumes pthreads for Solaris.
# -DALL_INTERIOR_POINTERS allows all pointers to the interior
#   of objects to be recognized.  (See gc_priv.h for consequences.)
#   Alternatively, GC_all_interior_pointers can be set at process
#   initialization time.
# -DSMALL_CONFIG tries to tune the collector for small heap sizes,
#   usually causing it to use less space in such situations.
#   Incremental collection no longer works in this case.
# -DLARGE_CONFIG tunes the collector for unusually large heaps.
#   Necessary for heaps larger than about 500 MB on most machines.
#   Recommended for heaps larger than about 64 MB.
# -DDONT_ADD_BYTE_AT_END is meaningful only with -DALL_INTERIOR_POINTERS or
#   GC_all_interior_pointers = 1.  Normally -DALL_INTERIOR_POINTERS
#   causes all objects to be padded so that pointers just past the end of
#   an object can be recognized.  This can be expensive.  (The padding
#   is normally more than one byte due to alignment constraints.)
#   -DDONT_ADD_BYTE_AT_END disables the padding.
# -DNO_SIGNALS does not disable signals during critical parts of
#   the GC process.  This is no less correct than many malloc 
#   implementations, and it sometimes has a significant performance
#   impact.  However, it is dangerous for many not-quite-ANSI C
#   programs that call things like printf in asynchronous signal handlers.
#   This is on by default.  Turning it off has not been extensively tested with
#   compilers that reorder stores.  It should have been.
# -DNO_EXECUTE_PERMISSION may cause some or all of the heap to not
#   have execute permission, i.e. it may be impossible to execute
#   code from the heap.  Currently this only affects the incremental
#   collector on UNIX machines.  It may greatly improve its performance,
#   since this may avoid some expensive cache synchronization.
# -DGC_NO_OPERATOR_NEW_ARRAY declares that the C++ compiler does not support
#   the  new syntax "operator new[]" for allocating and deleting arrays.
#   See gc_cpp.h for details.  No effect on the C part of the collector.
#   This is defined implicitly in a few environments.  Must also be defined
#   by clients that use gc_cpp.h.
# -DREDIRECT_MALLOC=X causes malloc to be defined as alias for X.
#   Unless the following macros are defined, realloc is also redirected
#   to GC_realloc, and free is redirected to GC_free.
#   Calloc and strdup are redefined in terms of the new malloc.  X should
#   be either GC_malloc or GC_malloc_uncollectable, or
#   GC_debug_malloc_replacement.  (The latter invokes GC_debug_malloc
#   with dummy source location information, but still results in
#   properly remembered call stacks on Linux/X86 and Solaris/SPARC.
#   It requires that the following two macros also be used.)
#   The former is occasionally useful for working around leaks in code
#   you don't want to (or can't) look at.  It may not work for
#   existing code, but it often does.  Neither works on all platforms,
#   since some ports use malloc or calloc to obtain system memory.
#   (Probably works for UNIX, and win32.)  If you build with DBG_HDRS_ALL,
#   you should only use GC_debug_malloc_replacement as a malloc
#   replacement.
# -DREDIRECT_REALLOC=X causes GC_realloc to be redirected to X.
#   The canonical use is -DREDIRECT_REALLOC=GC_debug_realloc_replacement,
#   together with -DREDIRECT_MALLOC=GC_debug_malloc_replacement to
#   generate leak reports with call stacks for both malloc and realloc.
#   This also requires the following:
# -DREDIRECT_FREE=X causes free to be redirected to X.  The
#   canonical use is -DREDIRECT_FREE=GC_debug_free.
# -DIGNORE_FREE turns calls to free into a noop.  Only useful with
#   -DREDIRECT_MALLOC.
# -DNO_DEBUGGING removes GC_dump and the debugging routines it calls.
#   Reduces code size slightly at the expense of debuggability.
# -DJAVA_FINALIZATION makes it somewhat safer to finalize objects out of
#   order by specifying a nonstandard finalization mark procedure  (see
#   finalize.c).  Objects reachable from finalizable objects will be marked
#   in a separate postpass, and hence their memory won't be reclaimed.
#   Not recommended unless you are implementing a language that specifies
#   these semantics.  Since 5.0, determines only the initial value
#   of GC_java_finalization variable.
# -DFINALIZE_ON_DEMAND causes finalizers to be run only in response
#   to explicit GC_invoke_finalizers() calls.
#   In 5.0 this became runtime adjustable, and this only determines the
#   initial value of GC_finalize_on_demand.
# -DATOMIC_UNCOLLECTABLE includes code for GC_malloc_atomic_uncollectable.
#   This is useful if either the vendor malloc implementation is poor,
#   or if REDIRECT_MALLOC is used.
# -DHBLKSIZE=ddd, where ddd is a power of 2 between 512 and 16384, explicitly
#   sets the heap block size.  Each heap block is devoted to a single size and
#   kind of object.  For the incremental collector it makes sense to match
#   the most likely page size.  Otherwise large values result in more
#   fragmentation, but generally better performance for large heaps.
# -DUSE_MMAP use MMAP instead of sbrk to get new memory.
#   Works for Solaris and Irix.
# -DUSE_MUNMAP causes memory to be returned to the OS under the right
#   circumstances.  This currently disables VM-based incremental collection.
#   This is currently experimental, and works only under some Unix,
#   Linux and Windows versions.
# -DMMAP_STACKS (for Solaris threads) Use mmap from /dev/zero rather than
#   GC_scratch_alloc() to get stack memory.
# -DPRINT_BLACK_LIST Whenever a black list entry is added, i.e. whenever
#   the garbage collector detects a value that looks almost, but not quite,
#   like a pointer, print both the address containing the value, and the
#   value of the near-bogus-pointer.  Can be used to identifiy regions of
#   memory that are likely to contribute misidentified pointers.
# -DKEEP_BACK_PTRS Add code to save back pointers in debugging headers
#   for objects allocated with the debugging allocator.  If all objects
#   through GC_MALLOC with GC_DEBUG defined, this allows the client
#   to determine how particular or randomly chosen objects are reachable
#   for debugging/profiling purposes.  The gc_backptr.h interface is
#   implemented only if this is defined.
# -DGC_ASSERTIONS Enable some internal GC assertion checking.  Currently
#   this facility is only used in a few places.  It is intended primarily
#   for debugging of the garbage collector itself, but could also
# -DDBG_HDRS_ALL Make sure that all objects have debug headers.  Increases
#   the reliability (from 99.9999% to 100% mod. bugs) of some of the debugging
#   code (especially KEEP_BACK_PTRS).  Makes -DSHORT_DBG_HDRS possible.
#   Assumes that all client allocation is done through debugging
#   allocators.
# -DSHORT_DBG_HDRS Assume that all objects have debug headers.  Shorten
#   the headers to minimize object size, at the expense of checking for
#   writes past the end of an object.  This is intended for environments
#   in which most client code is written in a "safe" language, such as
#   Scheme or Java.  Assumes that all client allocation is done using
#   the GC_debug_ functions, or through the macros that expand to these,
#   or by redirecting malloc to GC_debug_malloc_replacement.
#   (Also eliminates the field for the requested object size.)
#   occasionally be useful for debugging of client code.  Slows down the
#   collector somewhat, but not drastically.
# -DSAVE_CALL_COUNT=<n> Set the number of call frames saved with objects
#   allocated through the debugging interface.  Affects the amount of
#   information generated in leak reports.  Only matters on platforms
#   on which we can quickly generate call stacks, currently Linux/(X86 & SPARC)
#   and Solaris/SPARC and platforms that provide execinfo.h.
#   Default is zero.  On X86, client
#   code should NOT be compiled with -fomit-frame-pointer.
# -DSAVE_CALL_NARGS=<n> Set the number of functions arguments to be
#   saved with each call frame.  Default is zero.  Ignored if we
#   don't know how to retrieve arguments on the platform.
# -DCHECKSUMS reports on erroneously clear dirty bits, and unexpectedly

=== debian/changelog ===
stalin (0.11-7) unstable; urgency=medium

  * make-single-file: avoid scc dependency with "cat -s" Call "cat -s"
    instead of replace-extra-blank-lines to avoid scc dependency.  Add
    0002-make-single-file-avoid-scc-dependency-with-cat-s.patch to address
    the issue.  Thanks to Christopher Cramer for reporting the problem and
    proposing an alternate solution. (Closes: 336506)

  * Don't specify -O0 on amd64 to avoid Debian bootstrap segfault.
    Segfault seen with Debian gcc 5.3.1-3, 4.9.3-10, and 4.6.4-7.

  * debian/rules: rely on /usr/share/dpkg/buildflags.mk for CFLAGS.

  * debian/rules: remove unused version and build_cpu vars.

  * Avoid duplication within Debian prebuilt sources.  After notcing that
    the amd64 and ia64 prebuilt sources are identical, avoid the
    duplication via symlinks or diffs.  The latter because the i386 and
    sparc sources differed in only one line.

  * Remove vestigial Debian prebuilt sparc and ia64 sources.

  * Add Debian arm64 to stalin.architectures.  Add
    0004-stalin.architectures-add-debian-arm64.patch to include the
    information.

  * Add Debian arm64 support.  Running a "make stalin-arch-arm64" after
    adding the arm64 ./stalin-architecture output to
    include/stalin.architectures revealed that the arm64 source is
    identical to amd64's.

  * Change the Debian package priority from extra to optional.  Optional
    is now preferred.

  * Change the debhelper compatibility level to 13.

 -- Rob Browning <rlb@defaultvalue.org>  Wed, 12 Oct 2022 15:58:40 -0500

stalin (0.11-6) unstable; urgency=medium

  [ Rob Browning ]
  * Move debian/.gitignore to ./ and add /.pc.
  * Move prebuilt ./stalin-arch-*.c files to debian/prebuilt-src/.

  [ Barak A. Pearlmutter ]
  * Remove obsolete debian/prerm.
  * Update depends, standards-version, section, priority, and homepage.
  * Expand copyright information and update for 0.11.
  * Add uscan support (debian/watch).
  * Switch to "3.0 (quilt)" source format.

  [ Rob Browning ]
  * Simplify override_dh_testdir since entire tree is now in git.
  * Update FSF address in debian/copyright.
  * Don't use debian/clean since it can't handle directories.
  * Switch to git-dpm.
  * Don't build/use the local libgc. (Closes: 778130)
  * Remove quilt build dependency.

 -- Rob Browning <rlb@defaultvalue.org>  Sat, 27 Jun 2015 11:34:59 -0500

stalin (0.11-5) unstable; urgency=low

  * Build with debugging information (gcc -g).

  * Remove build dependency on build-essential dpkg-dev package.
    Thanks to Manoj Srivastava <srivasta@debian.org> for the report.
    (closes: #553474)

  * Switch to debhelper which should fix issues with quilt and the clean
    target.  Thanks to Raphael Hertzog <hertzog@debian.org> for the
    report. (closes: 484910)

 -- Rob Browning <rlb@defaultvalue.org>  Sat, 31 Oct 2009 16:08:15 -0700

stalin (0.11-4) unstable; urgency=low

  * Really fix support for GNU/kFreeBSD.  Thanks again to Petr Salinger.
    (closes: #410810)

 -- Rob Browning <rlb@defaultvalue.org>  Fri,  2 Mar 2007 17:38:34 -0800

stalin (0.11-3) unstable; urgency=low

  * Turn off optimization on amd64 in order to be able to build within 2GB
    (hopefully).  (closes: #404734)

  * Fix support for GNU/kFreeBSD.  Thanks to Petr Salinger.
    (closes: #410810)

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 25 Feb 2007 13:46:35 -0800

stalin (0.11-2) unstable; urgency=low

  * Add kfreebsd-i386 and kfreebsd-amd64 to the architectures list.
    (closes: #314857)

  * Add real package alternatives for all of the virtual build
    dependencies.  (closes: #409450)

  * Use stalin's internal copy of libgc for now.  Debian's doesn't build
    with the same options (gc-Makefile.sed) and runs out of RAM during a
    bootstrap build.

  * Try using -O1 on amd64 to reduce memory usage.  Apparently -O2
    wouldn't build on a 2GB machine (see bug #404734).

 -- Rob Browning <rlb@defaultvalue.org>  Sun,  4 Feb 2007 11:29:45 -0800

stalin (0.11-1) unstable; urgency=medium

  * Migrate to a new upstream release; This should resolve the licensing
    issues with the opengl/xlib bindings. (closes: #375943)

  * Remove dependency on gcc-3.4.  The bug in gcc-4.1 has been fixed, and
    gcc-4.0 should work correctly as well.

  * Add dependencies on dpkg-dev; stalin-architecture-name uses it now.

  * Add support for ia64 and amd64.

  * Generate new precompiled C source for all architectures. (closes: #337169)

  * Drop support for m68k and arm since, if nothing else, their buildds
    don't have enough RAM.  For the same reason, don't add powerpc.
    (closes: #271836, #273130)

  * Change xlibs-dev dependency to libx11-dev. (closes: #347053)

  * Add build-time support for selection of scheme compiler,
    i.e. "stalin=./stalin ./build"

  * Change upstream gcc -O3 to -O2; -O3 requires much more RAM.

  * Generalize makefile architecture support (i.e. stalin-arch-%.c) and
    add all-precompiled-srcs target.

  * Test the build by running some benchmarks afterward.

  * Invoke benchmarks/make-clean from "make clean".

  * Drop stalin-wrapper; stalin itself handles things now.

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 12 Nov 2006 22:47:26 -0800

stalin (0.9+0.10alpha2-2) unstable; urgency=low

  * Migrate to quilt.

  * Fix problem where bootstrap required . to be in PATH.  Thanks to
    Christopher Cramer.  (closes: #336502)
    - debian/patches/misc.diff.
  
  * Rebuild against newer libgc.  (closes: #320972, #324498)

  * Build-Depend on and build with gcc-3.4 for now.  A gcc-4.0 build goes
    off into an infinite loop at the moment.  The compiler can now be
    selected via the CC environment variable.
    - debian/patches/allow-compiler-selection.diff
    - debian/control
    - debian/rules

  * Add simple after-build sanity checks.
    - debian/rules

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 30 Oct 2005 15:48:21 -0800

stalin (0.9+0.10alpha2-1) unstable; urgency=medium



=== debian/control ===
Source: stalin
Section: lisp
Priority: optional
Build-Depends: debhelper-compat (= 13), libgc-dev, libx11-dev,
  libgl1-mesa-dev | libgl-dev,
  freeglut3-dev | libglut-dev
Maintainer: Rob Browning <rlb@defaultvalue.org>
Standards-Version: 3.8.4
Homepage: http://www.ece.purdue.edu/~qobi/software.html

Package: stalin
Architecture: i386 amd64 arm64 ia64 sparc kfreebsd-i386 kfreebsd-amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, libgc-dev, dpkg-dev
Description: An extremely aggressive Scheme compiler
 stalin is an aggressive self-hosting Scheme compiler, designed to
 generate resource efficient stand-alone executables with very high
 computational performance.  It is a batch mode compiler like gcc, not
 an interpreter, and is designed to be used only after your code has
 stabilized.
 .
 It places a few limitations on the content of the source code.  For
 example, you may not LOAD or EVAL new expressions or procedure
 definitions at runtime, but in exchange, it is able to perform
 various global analyses which may allow it to transparently map
 Scheme types to C types and to use native C arithmetic operations on
 a per-expression basis, whenever such operations are proven safe.
 Further stalin can often reduce or eliminate run-time type checking
 and dispatching, and omit garbage collection for data of limited
 scope or accessibility, while omitting unreachable data altogether.
 .
 stalin also has a foreign procedure interface to both Xlib and OpenGL.

=== debian/rules ===
#!/usr/bin/make -f

SHELL := /bin/bash

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk

export ARCH_OPTS := $(CFLAGS)


%:
	dh $@

override_dh_testdir:
	dh_testdir stalin.sc

# Symlink the prebuilt file for the current architecture.  It may be
# that if the ./stalin-architecture output matches for two
# architectures, then the .c files will be the same, but all of the
# following matches were determined by creating the relevant
# stalin-arch-ARCH.c file (via "make stalin-arch-ARCH.c" after adding
# the entry to include/stalin.architectures) and then diffing it
# against existing prebuilt files.
stalin-arch-amd64.c:
	ln -sf debian/prebuilt-src/stalin-arch-amd64.c $@
stalin-arch-arm64.c:
	ln -sf debian/prebuilt-src/stalin-arch-amd64.c $@
stalin-arch-ia64.c:
	ln -sf debian/prebuilt-src/stalin-arch-amd64.c $@
stalin-arch-i386.c:
	ln -sf debian/prebuilt-src/stalin-arch-i386.c $@
stalin-arch-sparc.c:
	cp -a debian/prebuilt-src/stalin-arch-sparc.c $@.tmp
	patch $@.tmp debian/prebuilt-src/stalin-arch-sparc-from-i386.diff
	mv $@.tmp $@

override_dh_auto_build: stalin-arch-$(DEB_HOST_ARCH).c
	./build
	./build-gl-fpi

        # Tests
	rm -rf debian/tmp-test
	mkdir debian/tmp-test
	echo '(display "hello") (newline)' > debian/tmp-test/hello.scm
	cd debian/tmp-test && $(CURDIR)/stalin -On hello.scm
	test -x debian/tmp-test/hello
	test $$(debian/tmp-test/hello) = "hello"

        # These don't work on all debian platforms yet.
        #cd benchmarks && ./compile-and-run-stalin-old-benchmarks

override_dh_auto_install:
	rm -rf debian/stalin
	install -d debian/stalin

        # Binaries
	install -d debian/stalin/usr/bin
	cp debian/stalin-script debian/stalin/usr/bin/stalin

        # libs (some of these should be in share, but stalin doesn't make the
        # distinction ATM)
	install -d debian/stalin/usr/lib/stalin
	cp -r include/* debian/stalin/usr/lib/stalin
	install -s include/stalin debian/stalin/usr/lib/stalin/

	dh_auto_install

override_dh_clean:
	dh_clean
	rm -rf debian/tmp-test stalin-arch-$(DEB_HOST_ARCH).c

# Local variables:
# mode: makefile
# End:

=== debian/watch ===
version=3
ftp://ftp.ecn.purdue.edu/qobi/stalin-(.+).tgz
